!========================================
!     TAForLUA
!========================================
PROGRAM TestALUA
USE aForLua
!-----
 Type (TAForLUA) LUA
!-----
character(128) SS
logical LL, isNOPRINT
real R_ARR(100)
!========================================
! 1)  
!========================================
  WRITE(*,*) '*** TestALUA: Testing AForLUA class.'
  WRITE(*,*) '    Version= 0.2'
!-----
  call LUA%Create
  if (.not. LUA%LoadScript('source\TestALUA.lua') ) then
   write(*,*) '***Error LoadScript source\TestALUA.lua!'
   stop
  endif
  call LUA%debug


!========================================
! 2.1)      
!========================================
  call LUA%SetVal('via_real',123.45)
  call LUA%SetVal('via_int',-1952)
  call LUA%SetVal('via_bool',.FALSE.)
  call LUA%SetVal('via_char','Hello, Wasia!')
  call LUA%SetVal('Temp',224.5)

! ----   -----
  R_ARR(1:6) = (/ 0.111, 0.22, 0.33, 0.44,0.55,0.66 /)
  LenARR = 6
  call LUA%SetVal('via_forarr',R_ARR,LenARR)

!========================================
! 2.2)  
!========================================
  call LUA%OpenTable
   call LUA%SetTableEntry('phi_real',1952.12)
   call LUA%SetTableEntry('phi_bool',.false.)
   call LUA%SetTableEntry('phi_char','Googs Villy')
   call LUA%SetTableEntry('phi_int',666)
  call LUA%CloseTable('phi')
!========================================
! 3)  
!========================================
  if (.not. LUA%DoScript() )  then
   write(*,*) '***Error DoScript...'
   stop
  endif

!========================================
! 4)   
!========================================
  WRITE(*,*) '=FOR= Value of Global Variables ====='

  if(LUA%GetVal('via_char',SS))  write(*,*) 'FOR: via_char=>',trim(SS)//'<'
  if(LUA%GetVal('via_real',RR))  write(*,*) 'FOR: via_real= ',RR
  if(LUA%GetVal('via_bool',LL))  write(*,*) 'FOR: via_bool= ',LL
  if(LUA%GetVal('via_int',II))  write(*,*) 'FOR: via_int= ',II

!========================================
! 5)   
!========================================
  WRITE(*,*) '=FOR= Values of Global Array ====='
  LenARR = 100
  if(LUA%GetVal('via_rarr',R_ARR,LenARR)) &
      write(*,*) 'FOR: via_rarr= ',R_ARR(1:LenARR)
!  ---    --
  if(LUA%GetVal('via_char',SS))  write(*,*) 'FOR: via_char=>',trim(SS)//'<'


!========================================
! 6.1)   - ANSI2OEM
!========================================
  SS = ',  - Steps'
  if(LUA%SetFun('ANSI2OEM')) then
    call LUA%SetARG(SS)
    LL = LUA%DoFun()
    LL = LUA%GetFunResult(SS)
    write(*,*) 'Ret ANSI2OEM=>'//trim(SS)//'<'
  else
     write(*,*) '***Error SetFun(ANSI2OEM).'
  endif



!========================================
! 6.2)      
!========================================

 write(*,*) ' ----- run "test_table_arg" ---------'
 if(LUA%SetFun('test_table_arg')) then
   call LUA%SetARG(.TRUE.)
   call LUA%OpenTableArg
     call LUA%SetTableARG('xx',0.25)
     call LUA%SetTableARG('yy',6.25)
     call LUA%SetTableARG('name','Anes20xe')
     call LUA%SetTableARG('id',77)
   call LUA%CloseTableArg

   if(LUA%DoFun()) then
     if(LUA%GetFunResult(FF))  write(*,*) ' FF=', FF
   endif
 else
    write(*,*) ' *****ERROR run "test_table_arg"!'
 endif


!========================================
! 6.3)   - ic_cylind
!========================================
  isNOPRINT = .TRUE.
  do ix=1,10
    do iy=1,10
      xx = 0.1*ix
      yy = 0.2*iy
      if(LUA%SetFun('ic_cylind')) then
        call LUA%SetARG(isNOPRINT)
        call LUA%SetARG(xx)
        call LUA%SetARG(yy)
        if(.not.LUA%DoFun()) then
           write(*,*) '***Error doFun(ic_cylind).'
           exit
        endif
        if(.not.LUA%GetFunResult(FF))  then
           write(*,*) '***Error GetFunResult(ic_cylind).'
           exit
        endif
        if(.NOT.isNOPRINT) write(*,*) 'xx,yy,ff= ',xx,yy,ff
      else
        write(*,*) '***Error SetFun(ic_cylind).'
        EXIT
      endif
    enddo
   enddo

!========================================
! 6.4)   - ic_cylind2  
!            
!========================================
   call CPU_TIME(TimeBeg)
   NX = 800; NY = 800
   do ix=1,NX
    do iy=1,NY
      xx = 0.1*ix
      yy = 0.2*iy
      if(LUA%SetFun('ic_cylind')) then
        call LUA%SetARG(isNOPRINT)
        call LUA%SetARG(xx)
        call LUA%SetARG(yy)
        if(.not.LUA%DoFun()) exit
        if(.not.LUA%GetFunResult(FF))  exit
      else
        EXIT
      endif
    enddo
   enddo
   call CPU_TIME(TimeEnd)
   write(*,'(a,f10.3,a)') 'LUA TIME RUN=',(TimeEnd - TimeBeg)*1000.,' ms'

!========================================
! 6.5)   - FOR_cylind  
!========================================
   call CPU_TIME(TimeBeg)
   do ix=1,NX
    do iy=1,NY
      xx = 0.1*ix
      yy = 0.2*iy
      call for_cylind(.TRUE.,xx,yy,ff)
    enddo
   enddo
   call CPU_TIME(TimeEnd)
   write(*,'(a,f10.3,a)') 'FOR TIME RUN=',(TimeEnd - TimeBeg)*1000.,' ms'



!=======================
 call LUA%FREE
end program

subroutine for_cylind(isNoPrint,x, y,ff)
 logical isNoPrint
  if(isNoPrint) then
    ff = exp(sin(SQRT(x**2+y**2)))
  else
    ff = sqrt(x**2+y**2)
    write(*,*) 'v=',ff
  endif
end subroutine

