!----------------------------------------------------------
! Anes20XE: 
!----------------------------------------------------------
!         :  
!          : VIA
!----------------------------------------------------------
!        
!         LUA-
!----------------------------------------------------------
!  VIA 02.11.12:  
!---------------------------------------------------------- 

module myDATA
 use aForLua
 use auTOOLS
!-----
  Type (TAForLUA) LUA
  real SZ
  real, parameter:: PII = 3.1416
  integer NoTETA,NoZ
  real DTETA
  character(256) :: NameSTL,NameIN

!---------
contains
!---------
  real function GetSurf(z) result(Ret) 
   if(.NOT.LUA%SetFun('surf')) goto 111
   call LUA%SetARG(z)
   if(.not.LUA%DoFun()) goto 222
   if(.not.LUA%GetFunResult(Ret))  goto 222
   return
! -----     
 111  call WERR('     surf.')
   stop
 222  call WERR('   surf.')
   stop
  end function
  
  subroutine WERR(MSG)
     character(*) MSG
     call WriteConsole('*: '//trim(MSG))
     STOP
  end subroutine   
  
end module

Program aCreateAxiSTL
 use auTOOLS
 use myDATA
!------
  call InitUtil
  call WriteConsole('aCreateAxiSTL:    STL-, '// &
                    'ver. 0.1')
  NoARG = COMMAND_ARGUMENT_COUNT()
  if(NoARG.NE.1) then
    call WriteConsole('aCreateAxiSTL:  :')
    write(*,*) '  aCreateAxiSTL.exe <LUA-file>'
    STOP
  endif
!------
! 1)  LUA-   
!
  CALL GET_COMMAND_ARGUMENT(1, NameIN)
  call toLOWER(NameIN)
  k = INDEX(NameIN,'.lua',back=.TRUE.)
  if(k.EQ.0)  NameIN = trim(NameIN)//'.lua'
  if(.not.IsFileExists(NameIN)) call WERR(' : '//trim(NameIN))
!------
! 2)    LUA-
!
  call LUA%Create
  if (.not. LUA%LoadScript(NameIN) ) call WERR('  : '//trim(NameIN))
  if (.not. LUA%DoScript() )  call WERR('  : '//trim(NameIN))
!------
! 3)   
!
  if(.not.LUA%GetVal('namestl',NameSTL)) call WERR('  : namestl')
  call toLOWER(NameSTL)
  if(k.EQ.0)  NameSTL = trim(NameSTL)//'.stl'

  if(.NOT.LUA%GetVal('nz',NoZ)) NoZ = 50
  if(.NOT.LUA%GetVal('nteta',NoTETA)) NoTETA = 64
  if(.not.LUA%IsFunExists('surf')) call WERR('   surf')
  if(.not.LUA%GetVal('sz',SZ)) call WERR('    sz')

!------
! 4) 
!
   call atOpenSaveSTL(NameSTL,'create by AxiStl', 0,.FALSE.)
   
!-----
!  4.1.   
!
   DZ = SZ/NoZ
   DTETA = 2.*PII/NoTETA
   do iz = 1, NoZ 
     Z1 = DZ*(iz-1)
     Z2 = DZ*iz
     do ifi = 1,NoTETA
       Fi1 = DTETA*(ifi-1)
       Fi2 = DTETA*ifi
       call CreateRect(Z1,Z2,Fi1,Fi2)
     enddo
   enddo
!-----
!   
!
   call CylEnds(0.0, -1)
   call CylEnds(SZ, 1)
 
!-----
   call atCloseSaveSTL 
!-----
   call WriteConsole(' "'//trim(NameSTL)//'  !')   
 end program
 
 subroutine CreateRect(Z1,Z2,Fi1,Fi2)
  use auTOOLS
  use myDATA
  real P1(3), P2(3), P3(3), P4(3)
!-----
  RR1 = GetSurf(Z1); RR2 = GetSurf(Z2)
  P1(1:3) = (/ RR1*SIN(FI1), RR1*COS(FI1),  Z1 /)
  P2(1:3) = (/ RR2*SIN(FI1), RR2*COS(FI1),  Z2 /)
  P3(1:3) = (/ RR2*SIN(FI2), RR2*COS(FI2),  Z2 /)
  P4(1:3) = (/ RR1*SIN(FI2), RR1*COS(FI2),  Z1 /)
  call atAddRectSTL(P1,P2,P3,P4)
end subroutine
 
subroutine CylEnds(Z,iNorm)
  use auTOOLS
  use myDATA
  real P1(3), P2(3), P3(3)
!-----
  RR = GetSurf(Z)
  P1(1:3) = (/ 0.0, 0.0, z /)
  P2(1:3) = (/ 0.0, 0.0, z /)
  P3(1:3) = (/ 0.0, 0.0, z /)
!-----
  do I=1,NoTETA
    Fi1 = DTETA*(I-1)
    Fi2 = DTETA*I
    if(iNorm.EQ.-1) then
      P1(1) = RR*SIN(Fi1); P1(2) = RR*COS(Fi1)
      P2(1) = RR*SIN(Fi2); P2(2) = RR*COS(Fi2)
    else
      P2(1) = RR*SIN(Fi1); P2(2) = RR*COS(Fi1)
      P1(1) = RR*SIN(Fi2); P1(2) = RR*COS(Fi2)
    endif
    call atAddFacetSTL(P1,P2,P3)
  end do  
end subroutine     