--[[===================================
     Anes20XE
     LUA
 --------------------------------------
  VIA 21.10.12:  
]]--===================================


--=================================
--     trim -   
--    ""   inilazy.lua:
--   author Alexandr Leykin (leykina@gmail.com)
--=================================
function trim(SS)
--[[ 
 :
   ^       ::     
   $       ::  
   %s*     ::    
   ^%s*    ::      ->       
   %s*$    ::      ->       
   .       ::  
   -       ::       
  :
  1)  match    ,  . 
  1)         ,    
]]--



 local line = SS:match("^%s*(.-)%s*$")
 return line
end

--=================================
--     trim -   
--    
--=================================
function trimZZ(SS)
 local ic = string.find(SS,"%S")    --   
 if ic == nil then return "" end
--    --
 local S = SS:sub(ic)
--    --
 local len = string.len(S)
 local ilast =  len
 for i = len,1,-1 do
     if S:sub(i,i) ~= " " then ilast = i; break end
 end
 if ilast ~= len then S = S:sub(1,ilast) end
 return S
end


--======================================
-- -             ToRusLOWER
--======================================
function ToRusLOWER(S)
  SOUT = ""
  le = string.len(S)
  if(le == 0) then return "" end
  for i=1,le,1 do
    local ic = S:byte(i)
    if((ic >= 65) and (ic <= 90))  then ic = ic +32 end
    if((ic >= 192) and (ic <=223))  then ic = ic +32 end
    SQUT = SOUT..string.char(ic) 
  end
  return SOUT
end



--======================================
--      ANSI2OEM   
--======================================
function ANSI2OEM(Msg)
 S = Msg
-- -----------
 SOUT = '' 
 L = string.len(Msg)
 for i = 1,L,1 do 
	IC = string.byte(S,i)
    IDif = 0
    if (IC >= 192) and (IC <= 239) then IDif = -64 end
    if(IC >= 240 and IC <= 255) then IDif = -16 end
    if (Idif ~= 0) then
        ch = string.char(IC+IDif)
    else
        ch = string.char(i,i)
    end
    SOUT = SOUT..ch
 end
 return SOUT
end 

--======================================
--      WriteConsole   
--======================================
function WriteConsole(...)
  local farg = {...}
  local s  
   s = ""
   for ids,n in ipairs(farg) do 
     s = s ..' '.. n
   end
  io.write(ANSI2OEM(s).."\n")
end 

--// TODO ():    TO DO

-- ====================================
--       PrintTable
-- ====================================
 function PrintTable(nt,t)
    print(" -- Print of table \""..nt.."\" --")
    for key, value in pairs(t) do
      print("key=",key," value=",value)
    end
    if(getmetatable(t) ~=nil) then
      PrintTable("MetaTable of '"..nt.."'",getmetatable(t))
    end
 end


