!==================================================
! aLUA :   c LUA      2003
!==================================================
! :   -  liblua52.a,
!               LUA API 5.2.1  GCC
! ;
! 1)   gFortran 4.6   ( 
!      -)
!==================================================
! VIA 25.10.12: 
!==================================================
MODULE lua_interface
!  USE iso_c_binding, only: C_CHAR, C_NULL_CHAR, C_INT, C_PTR, &
!                           C_FUNPTR, C_DOUBLE,C_F_POINTER, c_size_t, C_NULL_PTR, &
!                           c_loc, c_funloc,C_NULL_FUNPTR
  USE iso_c_binding
  IMPLICIT NONE
!--------------------------------------------------
! 1)  LUA-
!--------------------------------------------------
  INTEGER(c_int) :: LUA_TNIL = 0
  INTEGER(c_int) :: LUA_TBOOLEAN = 1
  INTEGER(c_int) :: LUA_TLIGHTUSERDATA = 2
  INTEGER(c_int) :: LUA_TNUMBER = 3
  INTEGER(c_int) :: LUA_TSTRING = 4
  INTEGER(c_int) :: LUA_TTABLE = 5
  INTEGER(c_int) :: LUA_TFUNCTION = 6
  INTEGER(c_int) :: LUA_TUSERDATA = 7
  INTEGER(c_int) :: LUA_TTHREAD = 8

!typedef struct luaL_Reg {
!  const char *name;
!  lua_CFunction func;
!} luaL_Reg;
 integer, parameter:: MAX_FENTRY = 200
 Type,bind(C):: TluaL_Reg
    type(c_ptr) fname
    type(c_funptr) func
 end type
 Type(TluaL_Reg),bind(C),target::  luaL_Reg(MAX_FENTRY)
 character(64), target:: ForName(MAX_FENTRY)  
 integer :: NoReg = 0
 
!--------------------------------------------------
! 2) lua API 
!--------------------------------------------------
  INTERFACE

    subroutine lua_close(L) bind(c, name="lua_close")
      use, intrinsic :: iso_c_binding, only: c_ptr
      type(c_ptr), value :: L
    end subroutine lua_close

    subroutine lua_error(L) bind(c, name="lua_error")
      use, intrinsic :: iso_c_binding, only: c_ptr
      type(c_ptr), value :: L
    end subroutine lua_error

    subroutine lua_createtable(L, narr, nrec) bind(c, name="lua_createtable")
      use, intrinsic :: iso_c_binding, only: c_ptr, c_int
      type(c_ptr), value :: L
      integer(kind=c_int), value :: narr
      integer(kind=c_int), value :: nrec
    end subroutine lua_createtable

    subroutine lua_getglobal(L, k) bind(c, name="lua_getglobal")
      use, intrinsic :: iso_c_binding, only: c_ptr, c_char
      type(c_ptr), value :: L
      character(kind=c_char), dimension(*) :: k
    end subroutine lua_getglobal


    subroutine lua_getfield(L, index, k) bind(c, name="lua_getfield")
      use, intrinsic :: iso_c_binding, only: c_ptr, c_int,c_char
      type(c_ptr), value :: L
      integer(kind=c_int), value :: index
      character(kind=c_char), dimension(*) :: k
    end subroutine lua_getfield


    subroutine lua_gettable(L, index) bind(c, name="lua_gettable")
      use, intrinsic :: iso_c_binding, only: c_ptr, c_int
      type(c_ptr), value :: L
      integer(kind=c_int), value :: index
    end subroutine lua_gettable


    function lua_gettop(L) bind(c, name="lua_gettop")
      use, intrinsic :: iso_c_binding, only: c_ptr, c_int
      type(c_ptr), value :: L
      integer(kind=c_int) :: lua_gettop
    end function lua_gettop

    subroutine lua_insert(L, index) bind(c, name="lua_insert")
      use, intrinsic :: iso_c_binding, only: c_ptr, c_int
      type(c_ptr), value :: L
      integer(kind=c_int) :: index
    end subroutine lua_insert

    function lua_isNumber(L, index) bind(c, name="lua_isnumber")
      use, intrinsic :: iso_c_binding, only: c_ptr, c_int
      type(c_ptr), value :: L
      integer(kind=c_int), value :: index
      integer(kind=c_int) :: lua_isnumber
    end function lua_isnumber

    function lua_next(L, index) bind(c, name="lua_next")
      use, intrinsic :: iso_c_binding, only: c_ptr, c_int
      type(c_ptr), value :: L
      integer(kind=c_int), value :: index
      integer(kind=c_int) :: lua_next
    end function lua_next

    function lua_pcallk(L, nargs, nresults, errfunc, ctx, k) bind(c, name="lua_pcallk")
      use, intrinsic :: iso_c_binding, only: c_ptr, c_int
      type(c_ptr), value :: L
      integer(kind=c_int), value :: nargs
      integer(kind=c_int), value :: nresults
      integer(kind=c_int), value :: errfunc
      integer(kind=c_int), value :: ctx
      type(c_ptr), value :: k
      integer(kind=c_int) :: lua_pcallk
    end function lua_pcallk

    subroutine lua_pushinteger(L, n) bind(c, name="lua_pushinteger")
      use, intrinsic :: iso_c_binding, only: c_ptr, c_int
      type(c_ptr), value :: L
      integer(kind=c_int), value :: n
    end subroutine lua_pushinteger

    subroutine lua_pushboolean(L, n) bind(c, name="lua_pushboolean")
      use, intrinsic :: iso_c_binding, only: c_ptr, c_int
      type(c_ptr), value :: L
      integer(kind=c_int), value :: n
    end subroutine lua_pushboolean





    subroutine lua_pushnil(L) bind(c, name="lua_pushnil")
      use, intrinsic :: iso_c_binding, only: c_ptr
      type(c_ptr), value :: L
    end subroutine lua_pushnil

    subroutine lua_pushnumber(L, n) bind(c, name="lua_pushnumber")
      use, intrinsic :: iso_c_binding, only: c_ptr, c_double
      type(c_ptr), value :: L
      real(kind=c_double), value :: n
    end subroutine lua_pushnumber

    subroutine lua_pushvalue(L, index) bind(c, name="lua_pushvalue")
      use, intrinsic :: iso_c_binding, only: c_ptr, c_int
      type(c_ptr), value :: L
      integer(kind=c_int), value :: index
    end subroutine lua_pushvalue

    subroutine lua_setfield(L, index, k) bind(c, name="lua_setfield")
      use, intrinsic :: iso_c_binding, only: c_ptr, c_int, c_char
      type(c_ptr), value :: L
      integer(kind=c_int), value :: index
      character(kind=c_char), dimension(*) :: k
    end subroutine lua_setfield

    subroutine lua_setglobal(L, k) bind(c, name="lua_setglobal")
      use, intrinsic :: iso_c_binding, only: c_ptr, c_char
      type(c_ptr), value :: L
      character(kind=c_char), dimension(*) :: k
    end subroutine lua_setglobal

    subroutine lua_settable(L, index) bind(c, name="lua_settable")
      use, intrinsic :: iso_c_binding, only: c_ptr, c_int
      type(c_ptr), value :: L
      integer(kind=c_int), value :: index
    end subroutine lua_settable

    subroutine lua_settop(L, index) bind(c, name="lua_settop")
      use, intrinsic :: iso_c_binding, only: c_ptr, c_int
      type(c_ptr), value :: L
      integer(kind=c_int), value :: index
    end subroutine lua_settop

    function lua_tolstring(L, index, len) bind(c, name="lua_tolstring")
      use, intrinsic :: iso_c_binding, only: c_ptr, c_int,c_size_t
      type(c_ptr), value :: L
      integer(kind=c_int), value :: index
      integer(kind=c_size_t) :: len
      type(c_ptr) :: lua_tolstring
    end function lua_tolstring
    
    
    function lua_tonumberx(L, index, isnum) bind(c, name="lua_tonumberx")
      use, intrinsic :: iso_c_binding, only: c_ptr, c_int,c_double
      type(c_ptr), value :: L
      integer(kind=c_int), value :: index
      integer(kind=c_int) :: isnum
      real(kind=c_double ) :: lua_tonumberx
    end function lua_tonumberx
    
    

    function lua_toboolean(L, index) bind(c, name="lua_toboolean")
      use, intrinsic :: iso_c_binding, only: c_ptr, c_int
      type(c_ptr), value :: L
      integer(kind=c_int), value :: index
      integer(kind=c_int) :: lua_toboolean
    end function lua_toboolean

    function lua_type(L, index) bind(c, name="lua_type")
      use, intrinsic :: iso_c_binding, only: c_ptr, c_int
      type(c_ptr), value :: L
      integer(kind=c_int), value :: index
      integer(kind=c_int) :: lua_type
    end function lua_type


    subroutine lua_pushlstring(L, S, len) bind(c, name="lua_pushlstring")
      use, intrinsic :: iso_c_binding, only: c_ptr, c_int, c_char
      type(c_ptr), value :: L
      integer(kind=c_int), value :: len
      character(kind=c_char), dimension(*) :: S
    end subroutine lua_pushlstring

    subroutine lua_pushstring(L, S) bind(c, name="lua_pushstring")
      use, intrinsic :: iso_c_binding, only: c_ptr, c_int, c_char
      type(c_ptr), value :: L
      character(kind=c_char), dimension(*) :: S
    end subroutine lua_pushstring

!     lua_createtable(L,0,0)
!    subroutine lua_newtable(L) bind(c, name="lua_newtable")
!      use, intrinsic :: iso_c_binding, only: c_ptr
!      type(c_ptr), value :: L
!    end subroutine lua_newtable





  end INTERFACE

!--------------------------------------------------
! 3) lua auxiliary library
!--------------------------------------------------
  INTERFACE


    subroutine luaL_SetFuncs(L,lreg,nup) bind(c, name="luaL_setfuncs")
      use, intrinsic :: iso_c_binding, only: c_ptr,c_char,c_int
      type(c_ptr), value :: L, lreg
      integer(kind=c_int),value :: nup
    end subroutine luaL_SetFuncs


    subroutine luaL_openlibs(L) bind(c, name="luaL_openlibs")
      use, intrinsic :: iso_c_binding, only: c_ptr
      type(c_ptr), value :: L
    end subroutine luaL_openlibs

    function luaL_newstate() bind(c, name="luaL_newstate")
      use, intrinsic :: iso_c_binding, only: c_ptr
      type(c_ptr) :: luaL_newstate
    end function luaL_newstate

    function luaL_loadfilex(L, filename, mode) bind(c, name="luaL_loadfilex")
      use, intrinsic :: iso_c_binding, only: c_ptr, c_int, c_char
      type(c_ptr), value :: L
      character(kind=c_char), dimension(*) :: filename
      character(kind=c_char), dimension(*) :: mode
      integer(kind=c_int) :: luaL_loadfilex
    end function luaL_loadfilex

    function luaL_loadstring(L, string) bind(c, name="luaL_loadstring")
      use, intrinsic :: iso_c_binding, only: c_ptr, c_int,c_char
      type(c_ptr), value :: L
      character(kind=c_char), dimension(*) :: string
      integer(kind=c_int) :: luaL_loadstring
    end function luaL_loadstring

  end INTERFACE

!--------------------------------------------------
! 4)   LUA
!--------------------------------------------------

!==================================================
contains
!==================================================
!--------------------------------------------------
!     flua_toNumber
!--------------------------------------------------
function flua_toNumber(L, index)
  use, intrinsic :: iso_c_binding, only: c_ptr, c_int,c_double
  type(c_ptr), value :: L
  integer :: index
  real(kind=c_double) flua_toNumber
  integer(kind=c_int) :: isnum
!-----
   flua_toNumber = lua_tonumberx(L,index,isnum)
end function

!--------------------------------------------------
!     flua_toLstring
!--------------------------------------------------
subroutine flua_tolstring(L, index, S)
  type(c_ptr), value :: L
  integer :: index,i
  integer :: lenS
  character,pointer,dimension(:) :: string
  character(len=*) S
!-----
  integer :: string_shape(1)
  integer(kind=c_int) :: c_index
  integer(kind=c_size_t) :: c_len
  type(c_ptr) :: c_string
!-----
  c_index = index
  c_string = lua_tolstring(L, c_index, c_len)
  lenS = int(c_len,kind=kind(lenS))
  string_shape(1) = lenS
  call c_f_pointer(c_string, string, string_shape)
!-----
  S = ' '
  do i = 1,min(c_len,len(S))  
    S(i:i) = string(i) 
  enddo
end subroutine


!--------------------------------------------------
!     flua_pushLstring
!--------------------------------------------------
subroutine flua_pushlstring(L, S)
  type(c_ptr), value :: L
  character(len=*) S
  character(len=1024) SBUF
  integer(kind=c_int) :: lenS
!-----
  SBUF = S
  lenS = len_trim(S)
  SBUF = trim(SBUF)//C_NULL_CHAR
  call lua_pushlstring(L, SBUF, lenS)
end subroutine

!--------------------------------------------------
!     flua_pop
!--------------------------------------------------
subroutine flua_pop(L, n)
    type(c_ptr) :: L
    integer, optional, intent(in) :: n
!-----
    integer(kind=c_int) :: n_c
    n_c = -2
    if (present(n)) n_c = -n-1
    call lua_settop(L, n_c)
end subroutine
  
!--------------------------------------------------
!     flua_setArrayField
!--------------------------------------------------
subroutine flua_setArrayField(L, i,RVal)  !  
   type(c_ptr) :: L
   integer i
   real(4) RVAL 
   real(kind=c_double ) :: Values
!  ---   
   Values = RVAL 
   call  lua_pushinteger(L, i);
   call  lua_pushnumber(L, Values);
   call  lua_settable(L, -3);
end subroutine


!==================================================
!      DLL
!==================================================
subroutine flua_reg_clear
  NoReg = 0
end subroutine

subroutine flua_reg_Add(FName,fun)
  character(*) FName
  interface
    function fun(L) bind(C)
      use, intrinsic :: iso_c_binding, only: c_ptr,c_int
      type(c_ptr), value :: L
      integer(kind=c_int) fun
    end function
  end interface
! -----
  NoReg = NoReg + 1
  luaL_Reg(NoReg)%func  = c_funloc(fun)
  ForName(NoReg)        = trim(Fname)//C_NULL_CHAR
  luaL_Reg(NoReg)%fname = c_loc(ForName(NoReg))
  luaL_Reg(NoReg+1)%func  = C_NULL_FUNPTR
  luaL_Reg(NoReg+1)%fname = C_NULL_PTR
end subroutine


end MODULE
